#include "stdafx.h"
#include "CommProp.h"
#include "MyCommProp1.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyCommProp1 Ƽ 

IMPLEMENT_DYNCREATE(CMyCommProp1, CPropertyPage)

CMyCommProp1::CMyCommProp1() : CPropertyPage(CMyCommProp1::IDD)
{
	//{{AFX_DATA_INIT(CMyCommProp1)
	//}}AFX_DATA_INIT
}

CMyCommProp1::~CMyCommProp1()
{
}

void CMyCommProp1::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyCommProp1)
	DDX_Control(pDX, IDC_EDIT1, m_Comm1StructVer);
	DDX_Control(pDX, IDC_EDIT4, m_Comm1MaxSendBuf);
	DDX_Control(pDX, IDC_EDIT3, m_Comm1MaxRecBuf);
	DDX_Control(pDX, IDC_EDIT2, m_Comm1MaxBrt);
	DDX_Control(pDX, IDC_LIST1, m_Comm1DevList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMyCommProp1, CPropertyPage)
	//{{AFX_MSG_MAP(CMyCommProp1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyCommProp1 ޼ ڵ鷯

void CMyCommProp1::GetService(LPCOMMPROP p_ComProp,CListBox& Service,HANDLE hHandle)
{
UINT Serv[] = {
	PST_RS232,			PST_FAX,	PST_LAT,	PST_MODEM,	PST_NETWORK_BRIDGE,
	PST_PARALLELPORT,   PST_RS422,	PST_RS423,	PST_RS449,	PST_SCANNER,
	PST_TCPIP_TELNET,	PST_UNSPECIFIED,	PST_X25};

CString ServList[] = {
	"RS232",			"FAX",		"LAT",	"",	" Ʈũ 긴",
	"з Ʈ",		"RS422",	"RS423",		"RS449","˳",
	"TCP/IP ڳ",		"",	"X.25ǥ",	"END"};
	
	if(hHandle != INVALID_HANDLE_VALUE) 
	 {	// ø Ʈ  
		for(int i = 0 ; ServList[i] != "END" ; i++)
		{
			if(Serv[i] == p_ComProp->dwProvSubType)
			{
				Service.AddString(ServList[i]);
			}
		 }
	}
	else
	{
		Service.AddString("Ұ");
	}
}

void CMyCommProp1::GetMaxBrt(LPCOMMPROP p_ComProp,CString& MaxBrt,HANDLE hHandle)
{

DWORD Brt[] = {
	BAUD_075,		BAUD_110,		BAUD_134_5,		BAUD_150,
	BAUD_300,		BAUD_600,		BAUD_1200,		BAUD_1800,
	BAUD_2400,		BAUD_4800,		BAUD_7200,		BAUD_9600,
	BAUD_14400,		BAUD_19200,		BAUD_38400,		BAUD_56K,
	BAUD_57600,		BAUD_115200,	BAUD_128K,		BAUD_USER};

CString BrtList[] = {
	"75",			"110",			"134.5",		"150",
	"300",			"600",			"1200",			"1800",	
	"2400",			"4800",			"7200",			"9600",
	"14400",		"19200",		"38400",		"56K",
	"57600",		"115200",		"128K",			" ",
	"END"};
	
	if(hHandle != INVALID_HANDLE_VALUE) 
	 {	// ø Ʈ  
		for(int i = 0 ; BrtList[i] != "END" ; i++)
		{
			if(Brt[i] == p_ComProp->dwMaxBaud)
			{
				MaxBrt= BrtList[i];
			}
		}
	}
}

BOOL CMyCommProp1::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

	COMMPROP*	p_ComProp; 	
	CString		msg, MaxBrt;

	p_ComProp = new COMMPROP;

	GetCommProperties(hHandle, p_ComProp);
	
	// ø Ʈ  
	GetService(p_ComProp, m_Comm1DevList, hHandle );
	// ü 
	if(hHandle != INVALID_HANDLE_VALUE) 
	{	// ø Ʈ  
		msg.Format("%d",p_ComProp->wPacketVersion);
		m_Comm1StructVer.SetWindowText(msg);
		// Ʈ ִ밪
		GetMaxBrt(p_ComProp,MaxBrt,hHandle);
		m_Comm1MaxBrt.SetWindowText(MaxBrt);
		//   ִ밪
		if(p_ComProp->dwMaxRxQueue == 0)
		{
			m_Comm1MaxRecBuf.SetWindowText("Ѿ");
		}
		else
		{
			msg.Format("%d",p_ComProp->dwMaxRxQueue);
			m_Comm1MaxRecBuf.SetWindowText(msg);
		}
		// Ź ִ밪
		if(p_ComProp->dwMaxTxQueue == 0)
		{
			m_Comm1MaxSendBuf.SetWindowText("Ѿ");
		}
		else
		{
			msg.Format("%d",p_ComProp->dwMaxTxQueue);
			m_Comm1MaxSendBuf.SetWindowText(msg);
		}
	 }
	delete p_ComProp;
	
	return TRUE;  
}
