// MyCommProp2.cpp : ø̼ 
//

#include "stdafx.h"
#include "CommProp.h"
#include "MyCommProp2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyCommProp2 Ƽ 

IMPLEMENT_DYNCREATE(CMyCommProp2, CPropertyPage)

CMyCommProp2::CMyCommProp2() : CPropertyPage(CMyCommProp2::IDD)
{
	//{{AFX_DATA_INIT(CMyCommProp2)
	//}}AFX_DATA_INIT
}

CMyCommProp2::~CMyCommProp2()
{
}

void CMyCommProp2::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyCommProp2)
	DDX_Control(pDX, IDC_LIST14, m_Comm1Func);
	DDX_Control(pDX, IDC_LIST13, m_Comm1Stop);
	DDX_Control(pDX, IDC_LIST12, m_Comm1BitLenList);
	DDX_Control(pDX, IDC_LIST11, m_Comm1BrtList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMyCommProp2, CPropertyPage)
	//{{AFX_MSG_MAP(CMyCommProp2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyCommProp2 ޼ ڵ鷯
void CMyCommProp2::GetBrtList(LPCOMMPROP p_ComProp,CListBox& BrtListBox,HANDLE hHandle)
{
UINT Brt[] = {
	BAUD_075,		BAUD_110,		BAUD_134_5,		BAUD_150,
	BAUD_300,		BAUD_600,		BAUD_1200,		BAUD_1800,
	BAUD_2400,		BAUD_4800,		BAUD_7200,		BAUD_9600,
	BAUD_14400,		BAUD_19200,		BAUD_38400,		BAUD_56K,
	BAUD_57600,		BAUD_115200,	BAUD_128K,		BAUD_USER};
CString BrtList[] = {
	"75",			"110",			"134.5",		"150",
	"300",			"600",			"1200",			"1800",
	"2400"			"4800",			"7200",			"9600",
	"14400",		"19200",		"38400",		"56K",
	"57600",		"115200",		"128K",			"",
"END"};
	
	if(hHandle != INVALID_HANDLE_VALUE) 
	 {	// ø Ʈ  
		for(int i = 0 ; BrtList[i] != "END" ; i++)
		{
			if(Brt[i] & p_ComProp->dwSettableBaud )
			{
				BrtListBox.AddString(BrtList[i]);
			}
		}
	}
}

void CMyCommProp2::GetBitLenList(LPCOMMPROP p_ComProp,CListBox& BitLenBox,HANDLE hHandle)
{
UINT BitLen[] = {
	DATABITS_5,		DATABITS_6,		DATABITS_7,		DATABITS_8,
	DATABITS_16,	DATABITS_16X
};
CString BitLenList[] = {
	"BITS_5",		"BITS_6",		"BITS_7",		"BITS_8",
	"BITS_16",		"BITS_16X",		"END"};
	
	if(hHandle != INVALID_HANDLE_VALUE) 
	 { // ø Ʈ  
		for(int i = 0 ; BitLenList[i] != "END" ; i++)
		{
			if(BitLen[i] & p_ComProp->wSettableData)
			{
				BitLenBox.AddString(BitLenList[i]);
			}
		}
	}
}

void CMyCommProp2::GetStopList(LPCOMMPROP p_ComProp,CListBox& StopBox,HANDLE hHandle)
{

UINT Stop[] = {
	STOPBITS_10,	STOPBITS_15,	STOPBITS_20,	PARITY_NONE,
    PARITY_ODD ,	PARITY_EVEN,	PARITY_MARK ,	PARITY_SPACE};
CString StopList[] = {
	"1",			"1.5",			"2",			"иƼ ",
	"Ȧ",			"¦",			"ũ",			"̽",
	"END"};
	
	if(hHandle != INVALID_HANDLE_VALUE) 
	 {	// ø Ʈ  
		for(int i = 0 ; StopList[i] != "END" ; i++)
		{
			if(Stop[i] & p_ComProp->wSettableStopParity)
			{
				StopBox.AddString(StopList[i]);
			}
		}
	}
}

void CMyCommProp2::GetFuncList(LPCOMMPROP p_ComProp,CListBox& FuncBox,HANDLE hHandle)
{

UINT Func[] = {PCF_16BITMODE,PCF_DTRDSR,PCF_INTTIMEOUTS,PCF_PARITY_CHECK,
			   PCF_RLSD,PCF_RTSCTS,PCF_SETXCHAR,PCF_SPECIALCHARS,
			   PCF_TOTALTIMEOUTS,PCF_XONXOFF};

CString FuncList[] = {"Ư16BIT","DTR/DSR","͹ ŸӾƿ",
					  "иƼ üũ","RLSD(CD)","RTS/CTS","XON/XOFF","Ư",
					  " ŸӾƿ","X÷ ","END"};
	
	if(hHandle != INVALID_HANDLE_VALUE) 
	 {// ø Ʈ  
		for(int i = 0 ; FuncList[i] != "END" ; i++)
		{
			if(Func[i] & p_ComProp->dwProvCapabilities)
			{
				FuncBox.AddString(FuncList[i]);
			}

		 }
	}
}

BOOL CMyCommProp2::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	COMMPROP* p_ComProp; 	
	CString msg;

	p_ComProp = new COMMPROP;
	GetCommProperties(hHandle, p_ComProp);
	//  Baud rate
	GetBrtList(p_ComProp, m_Comm1BrtList,hHandle);
	//   Ʈ 
	GetBitLenList(p_ComProp, m_Comm1BitLenList,hHandle); 
	//   ž Ʈ
	GetStopList(p_ComProp, m_Comm1Stop,hHandle);
	//   Լ
	GetFuncList(p_ComProp, m_Comm1Func,hHandle);
	delete p_ComProp;
	
	return TRUE; 
}
